<?php

namespace Flat101\EnhancedEcommerce\Block\Impressions;

use Flat101\EnhancedEcommerce\Api\DataLayerListInterface;
use Flat101\EnhancedEcommerce\Block\AbstractDatalayer;
use Flat101\EnhancedEcommerce\Factory\DataLayerFactory;
use Flat101\EnhancedEcommerce\Helper\Config;
use Flat101\EnhancedEcommerce\Model\DataLayer\Impressions\SuccessImpressionView as SuccessImpressionViewGA4;
use Flat101\EnhancedEcommerce\Model\DataLayer\Impressions\SuccessImpressionView as SuccessImpressionViewUA;
use Magento\Framework\App\Response\RedirectInterface;
use Magento\Framework\Event\Manager;
use Magento\Framework\Serialize\SerializerInterface;
use Magento\Framework\UrlInterface;
use Magento\Framework\View\Element\Template;
use Magento\Sales\Api\OrderRepositoryInterface;

class SuccessImpression extends AbstractDatalayer
{
    private SuccessImpressionViewGA4 $successImpressionViewGA4;
    private SuccessImpressionViewUA $successImpressionViewUA;

    public function __construct(

        SuccessImpressionViewGA4 $successImpressionViewGA4,
        SuccessImpressionViewUA $successImpressionViewUA,
        Template\Context $context,
        DataLayerListInterface $dataLayerList,
        DataLayerFactory $dataLayerFactory,
        SerializerInterface $serializer,
        UrlInterface $url,
        Config $config,
        RedirectInterface $redirect,
        Manager $eventManage,
        OrderRepositoryInterface $orderRepository,
        array $data = []
    )
    {
        parent::__construct($context, $dataLayerList, $dataLayerFactory, $serializer, $url, $config, $redirect, $eventManage, $data);
        $this->successImpressionViewGA4 = $successImpressionViewGA4;
        $this->successImpressionViewUA = $successImpressionViewUA;
        $this->orderRepository = $orderRepository;
    }

    public function getJsonDataLayers(): ?string
    {

        $layers['GA4'] = $this->successImpressionViewGA4->getLayer()->getData();

        if (!$this->config->getIsDisabledUaDatalayer()) {
            $layers['UA'] = $this->successImpressionViewUA->getLayer()->getData();
        }
        return $this->serializer->serialize($layers);
    }

    public function getOrder($id): \Magento\Sales\Api\Data\OrderInterface
    {
        return $this->orderRepository->get($id);
    }

    public function getOrderData($layers)
    {
        $result = [];
        $data = $this->serializer->unserialize($layers);
        $order = $this->getOrder($data['GA4'][0]['order_id']);
        $payment = $order->getPayment();
        $method = $payment->getMethodInstance();
        $methodTitle = $method->getTitle();
        $result['title'] = $methodTitle;
        $result['shipping'] = $order->getShippingAmount();
        return $this->serializer->serialize($result);
    }

    public function getCurrentCurrency(): string
    {
        return $this->_storeManager->getStore()->getCurrentCurrency()->getCode();
    }
}
