<?php

namespace Flat101\EnhancedEcommerce\Model\DataLayerGa4\Impressions;

use Flat101\EnhancedEcommerce\Api\Data\DataLayerInterface;
use Flat101\EnhancedEcommerce\Model\UnsetProperty;
use Magento\Checkout\Model\Cart;
use Magento\Framework\Event\Manager;

class CheckoutImpressionView implements DataLayerInterface
{
    use UnsetProperty;

    public const CODE = 'checkoutStep';

    /**
     * @var Manager
     */
    private Manager $eventManager;

    /**
     * @var Cart
     */
    private \Magento\Checkout\Model\Cart $cart;

    public function __construct(
        Manager $eventManager,
        \Magento\Checkout\Model\Cart $cart
    ) {
        $this->eventManager = $eventManager;
        $this->cart = $cart;
    }

    public function getCode(): string
    {
        return static::CODE;
    }

    public function getLayer(): array|object|null
    {
        $productsInCart = $this->cart->getQuote()->getItemsCollection();
        $impression = 0 < count($productsInCart) ? $productsInCart : null;

        $this->eventManager->dispatch('flat101_enhancedecommerce_checkoutStep', [
            'dataLayer' => $impression,
        ]);

        return $impression;
    }
}
