define([
    'jquery'
], function ($) {
    'use strict';

    const EVENT = 'Filter';
    const EVENT_CATEGORY = 'Filter';


    function initBefore() {
        window.dataLayer = window.dataLayer || [];
    }

    function initBehavioralEvent(action, label) {
        initBefore();

        dataLayer.push({
            'event': EVENT,
            'eventCategory': EVENT_CATEGORY,
            'eventAction': action,
            'eventLabel': label
        });
    }

    return function () {
        $('a[class^="am-filter-item-"]').click( function (){
            let action = $(this).parents('[data-role="content"]').siblings('[data-role=title]').text();
            let label = $(this).find("span.label").text();

            initBehavioralEvent(action, label);
        });

        $('a[class="am-swatch-link"]').click( function (){
            let action = $(this).parents('[data-role="content"]').siblings('[data-role=title]').text();
            let label = $(this).attr('data-label');

            initBehavioralEvent(action, label);
        });
    }
});
