define([
    'jquery',
    'underscore'
], function ($, _) {
    'use strict';

    function initItemsGa4(action, products, currency, orderData, isDisabledUaDatalayer) {
        if (!isDisabledUaDatalayer && _.isArray(products.GA4)) {
            dataLayer.push({
                'event': 'transactionComplete',
                'ecommerce': {
                    'currency': currency,
                    [action]: products.GA4,
                    "purchase": {
                        "actionField": {
                            "id": products[0].order_id,
                            "revenue": products[0].base_price,
                            "tax": products[0].base_tax_amount,
                            "shipping": orderData.shipping,
                            "payment": orderData.payment
                        },
                        "product": products[0].product_options
                    }
                }
            });
        }
    }

    function initImpressionsUa(action, products, currency,orderData,) {
        if (_.isArray(products.UA)) {
            dataLayer.push({
                'event': 'transactionComplete',
                'ecommerce': {
                    'currencyCode': currency,
                    [action]: products.UA,
                    "purchase": {
                        "actionField": {
                            "id": products[0].order_id,
                            "revenue": products[0].base_price,
                            "tax": products[0].base_tax_amount,
                            "shipping": orderData.shipping,
                            "payment": orderData.payment
                        },
                        "product": products[0].product_options
                    }
                }
            });
        }
    }

    /**
     * @param {Object} config
     */
    return function (config) {

        console.log(config.impressions.GA4);
        console.log(config.impressions.GA4[0].order_id);
        if (
            _.has(config, 'impressions')
            && _.isObject(config.impressions)
            && _.isArray(config.impressions.GA4)
            && config.impressions.GA4.length > 0
        ) {
            initItemsGa4('items', config.impressions, config.currency, config.orderData);
            if (!config.isDisabledUaDatalayer && _.isArray(config.impressions.UA) && config.impressions.UA.length > 0) {
                initImpressionsUa('impressions', config.impressions, config.currency);
            }
        }
    }
});
